; V = Variable divers
; F = Flag, Register, simple On/OFf, Auswahl
; M = Zwischenspeicher
; C = Counter
; S = Startadressen Speicherbereiche
; K = Konstante


; R: = Routine
; SUB: = Subroutine

S_Save_Colors = $c800
V_Delay_x_256 = $9070 ; Counter für 16bit Schleife



Operator  Calc                     ;wird erst ab CBM prg Studio 2.8.0 benötigt!
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                      RASTERINTERRUPT                                OO
;OO                      def rasterzeilen                               OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
#region

;------------------------------------------
;STANDARD INTERRUPTS
;------------------------------------------

V_RASTER    = $20  ; Textmodus aktivieren / Sprechblasen
V_RASTER_1 = $49  ; Grafikmodus aktivieren
V_RASTER_2  = $84  ; Animation Augen, Münder, Bauch


;------------------------------------------
;NORBERT ERKLÄRT DIE WELT INTERRUPTS
;------------------------------------------

V_Raster_NEDW_1 = $01
V_Raster_NEDW_2 = $4a          ; ab hier: TOP Sprites (Interrupt5)
V_Raster_NEDW_3 = $a0           ; ab hier: bottom Sprites (Interrupt5)


;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                      AUGENANIMATION                                 OO
;OO                      variablen und register                         OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

;------------------------------------------
;NORBERT
;------------------------------------------
; Verzögerungszähler Norbert Augen auf/zu
C_Delay_Norbert = $9000  

; Norberts Augenstatus: 0= Auge zu , 1= Auge auf           
F_Eyes_open_Norbert = $9001


;------------------------------------------
;KLOSS
;------------------------------------------

; Zwinkern von Kloß auslösen, wenn GET_RND diesen Wert zurückbringt                
K_Ausloeser_Kloss = $88  

; Kloß Augenstatus: 0= Auge zu , 1= Auge auf           
F_Eyes_open_Kloss = $9020 

; Zum Verzögern des Augen-wieder-öffnens beim Blinken
C_Delay_Zwinkern_Kloss = $9021  

;------------------------------------------
;SPINNE
;------------------------------------------

; Zwinkern von Spinne auslösen, wenn GET_RND diesen Wert zurückbringt                            
K_Ausloeser_Spinne = $22                ; Spinne zwinkert bei diesem Wert
F_Eyes_open_Spinne = $9030  ; 0= Auge auf , 1= Auge zu
C_Delay_Zwinkern_Spinne = $9031      ; Zum Verzögern des Augenöffnens beim Blinken



; 1 x Zwinkern von Horst, wenn GET_RND diesen Wert zurückbringt          
K_Ausloeser_Horst = $44
F_Eyes_open_Horst = $9040                  ; 0= Auge auf , 1= Auge zu
C_Delay_Zwinkern_Horst = $9041                  ; Zum Verzögern des Augenöffnens beim Blinken
C_Delay_Cursor = $9050                  ; irgendeine, hoffentlich freie Speicherstelle
F_Cursor_on_off = $9051                  ; 0= Cursor weg , 1= Cursor da


;------------------------------------------
;CURSOR
;------------------------------------------
;63f4
CURSOR_PIXEL = $67cc

#320


;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                      Mundanimation                                  OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

 


C_delaycounter_sprachanimation = $9060 

M_Tastaturspeicher = $9061


F_SPRECHER = $9062 ; 1=Kkoss, 2 = Spinne

K_VERZoeGERUNG_MUND = #04

V_Sprachdauer = $9064
C_countdown_sprachdauer = $9065


;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                      HORST EXPLODIERT                               OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

S_shape01_in = $a000

;shape01_out = $6ba0+$38
;shape01_out = $6b00
S_shape01_out = $6d80

;shape1_c1_in = $bf40     ;(a000+1f40 + screenoffset)
;shape1_c2_in = $C332; ;(a000+2328 + screenoffset)

S_shape1_c1_in = $bf40     ;(a000+1f40 + screenoffset)
S_shape1_c2_in = $c328; ;(a000+2328 + screenoffset)

S_shape1_c1_out = VICSCREENRAM+$01b0
S_shape1_c2_out = VICCOLORRAM+$01b0

; Ist Horst schon explodiert?

F_Horst_schon_explodiert = $9068



;------------------------------------------
; RAHMEN UND HINTERGRUND
;------------------------------------------

V_Fillscreen_Color = #$00

V_Standard_Farbe_Hintergrund = #$00

V_Standard_Farbe_Rahmen = #$00

V_Standard_Farbe_Texthintergrund = #$0e


M_Fillscreen_Color = $9071

M_Standard_Farbe_Hintergrund = $9072

M_Standard_Farbe_Rahmen = $9073

M_Standard_Farbe_Texthintergrund = $9074

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                      TEXTAUSGABE                                    OO
;OO                      variablen, pointer, etc                        OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

M_Textstart= $9780                       ; Beginn des Textblockes
M_Lesezeichen = M_Textstart            ; Lesezeichen auf Anfang
MZ_Lesezeichen_Zero = $FB                    ; Zeropage für Adressierung

F_ohne_Taste  = $9781                             ;1 wenn die nächste Animation direkt geladen werden soll
K_Textblock_Ende = #$ff                        ; Ende des Animationsblocks
K_Next_Text_ohne_Taste = #$fe         ; nächste Sprechblase direkt laden
K_Textfenster = #120    ; Zeichenzahl Textfenster 3 Zeilen



;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                                                                     OO
;**********************    VIC DEFINITIONS ******************************
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

#region
;*** VIC-II Speicher-Konstanten

VICBASEADR = $4000                 ;2. 16KB Bank ($4000-$7fff)
VICSCREENBLOCKNO = 1               ;2. 1KB-Blocks für den Textbildschirm   





VICBITMAPBBLOCKNO = 1                           ;Nr. (0 - 1) des 8KB-Blocks für                                                 die BITMAP-Grafik      
VICCHARSETADR = 2*2048                          ;Adresse des Zeichensatzes;                                                     Charsetblockno 2               
VICCHARSETADR = VICCHARSETADR+$4000             ; Base-Adr. ist $4000
VICSCREENRAM = VICSCREENBLOCKNO*1024            ;Adresse des Bildschirmspeichers
VICSCREENRAM = VICSCREENRAM +VICBASEADR
VICBITMAPADR = VICBITMAPBBLOCKNO * 8192         ;Adresse der BITMAP
VICBITMAPADR = VICBASEADR + VICBITMAPADR
VICCOLORRAM = $D800

                
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DEFINITIONEN                                   OO
;OO                      SPRITES                                        OO
;OO                      Register, Variablen, Speicher                  OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO


SPRITE0X  = $D000                  ;(00) X-Position von Sprite 0
SPRITE0Y  = $D001                  ;(01) Y-Position von Sprite 0
SPRITE1X  = $D002                  ;(02) X-Position von Sprite 1
SPRITE1Y  = $D003                  ;(03) Y-Position von Sprite 1
SPRITE2X  = $D004                  ;(04) X-Position von Sprite 2
SPRITE2Y  = $D005                  ;(05) Y-Position von Sprite 2
SPRITE3X  = $D006                  ;(06) X-Position von Sprite 3
SPRITE3Y  = $D007                  ;(07) Y-Position von Sprite 3
SPRITE4X  = $D008                  ;(08) X-Position von Sprite 4
SPRITE4Y  = $D009                  ;(09) Y-Position von Sprite 4
SPRITE5X  = $D00A                  ;(10) X-Position von Sprite 5
SPRITE5Y  = $D00B                  ;(11) Y-Position von Sprite 5
SPRITE6X  = $D00C                  ;(12) X-Position von Sprite 6
SPRITE6Y  = $D00D                  ;(13) Y-Position von Sprite 6
SPRITE7X  = $D00E                  ;(14) X-Position von Sprite 7
SPRITE7Y  = $D00F                  ;(15) Y-Position von Sprite 7
SPRITESMAXX = $D010                  ;(16) Höhstes BIT der jeweiligen X-Position
                                   ;        da der BS 320 Punkte breit ist reicht
                                   ;        ein BYTE für die X-Position nicht aus!
                                   ;        Daher wird hier das 9. Bit der X-Pos
                                   ;        gespeichert. BIT-Nr. (0-7) = Sprite-Nr.
SPRITEACTIV = $D015                  ;(21) Bestimmt welche Sprites sichtbar sind
                                   ;        Bit-Nr. = Sprite-Nr.
SPRITEDOUBLEHEIGHT = $D017                  ;(23) Doppelte Höhe der Sprites
                                   ;        Bit-Nr. = Sprite-Nr.
SPRITEDEEP = $D01B                  ;(27) Legt fest ob ein Sprite vor oder hinter
                                   ;        dem Hintergrund erscheinen soll.
                                   ;        Bit = 1: Hintergrund vor dem Sprite
                                   ;        Bit-Nr. = Sprite-Nr.
SPRITEMULTICOLOR = $D01C                  ;(28) Bit = 1: Multicolor Sprite
                                   ;        Bit-Nr. = Sprite-Nr.
SPRITEDOUBLEWIDTH = $D01D                  ;(29) Bit = 1: Doppelte Breite des Sprites
                                   ;        Bit-Nr. = Sprite-Nr.
SPRITESPRITECOLL = $D01E                  ;(30) Bit = 1: Kollision zweier Sprites
                                   ;        Bit-Nr. = Sprite-Nr.
                                   ;        Der Inhalt wird beim Lesen gelöscht!!
SPRITEBACKGROUNDCOLL= $D01F                  ;(31) Bit = 1: Sprite / Hintergrund Kollision
                                   ;        Bit-Nr. = Sprite-Nr.
                                   ;        Der Inhalt wird beim Lesen gelöscht!
SPRITEMULTICOLOR0 = $D025                  ;(37) Spritefarbe 0 im Multicolormodus
SPRITEMULTICOLOR1 = $D026                  ;(38) Spritefarbe 1 im Multicolormodus
SPRITE0COLOR = $D027                  ;(39) Farbe von Sprite 0
SPRITE1COLOR = $D028                  ;(40) Farbe von Sprite 1
SPRITE2COLOR = $D029                  ;(41) Farbe von Sprite 2
SPRITE3COLOR = $D02A                  ;(42) Farbe von Sprite 3
SPRITE4COLOR = $D02B                  ;(43) Farbe von Sprite 4
SPRITE5COLOR = $D02C                  ;(44) Farbe von Sprite 5
SPRITE6COLOR = $D02D                  ;(45) Farbe von Sprite 6
SPRITE7COLOR = $D02E                  ;(46) Farbe von Sprite 7
;*******************************************************************************
;*** Die VIC II Register  -  ENDE                                            ***
;*******************************************************************************
SCREENRAM = $4400                  ;Beginn des Bildschirmspeichers
;NORBERT AUGEN
SPRITE0DATA = SCREENRAM+$03F8          ;Sprite-Pointer für die
                                   ;Adresse der Sprite-0-Daten
;KLOSS AUGEN
SPRITE1DATA = SCREENRAM+$03F9          ;wie eben, nur für Sprite-1
;SPINNE AUGEN
SPRITE2DATA = SCREENRAM+$03FA          ;wie eben, nur für Sprite-2
;HORST AUGEN
SPRITE3DATA = SCREENRAM+$03FB          ;wie eben, nur für Sprite-3
;NORBERT MUND
SPRITE4DATA = SCREENRAM+$03FC          ;Sprite-Pointer für die
                                   ;Adresse der Sprite-0-Daten
;NORBERT BAUCH
SPRITE5DATA = SCREENRAM+$03FD          ;wie eben, nur für Sprite-1
;KLOSS MUND
SPRITE6DATA = SCREENRAM+$03FE          ;wie eben, nur für Sprite-2
;SPINNE MUND
SPRITE7DATA = SCREENRAM+$03FF          ;wie eben, nur für Sprite-3
; Spritedaten ab $5000 = $4000 + $40*64

M_SPRITE0DATA =$9900  ; Zwischenspeicher für spritemultiplexer im Standardbild
M_SPRITE1DATA =$9901
M_SPRITE2DATA =$9902
M_SPRITE3DATA =$9903
M_SPRITE4DATA =$9904
M_SPRITE5DATA =$9905
M_SPRITE6DATA =$9906
M_SPRITE7DATA =$9907

;------------------------------------------
; SPRITE-OFFSETS FÜR STANDARDSPRITES
;------------------------------------------
V_Sprite_Sprechblase_1 = #$48   ; Zipfel 1 links
V_Sprite_Sprechblase_2 = #$49   ; Zipfel 2 rechts
V_Sprite_Sprechblase_3 = #$4a   ; Zipfel 3 gerade

V_Sprite_Sprechblase_4 = #$4b  ; Strich


SPRITE0OFFSET = #$40                   ;Norbert Augen Anim-Bloecke
SPRITE1OFFSET_BLICK_STANDARD = #$42     ;Kloß auge auf standard
SPRITE1OFFSET_AUGE_ZU = #$43                       
SPRITE1OFFSET_BLICK_ZU_NORBERT = #$4c 
SPRITE1OFFSET_BLICK_ZU_SPINNE = #$4d  
SPRITE2OFFSET = #$44                   ;Spinne Augen Anim-Bloecke
SPRITE3OFFSET = #$46                   ;Horst Augen Anim-Bloecke

SPRITE4OFFSET = #$6c                    ; Norbert Mund
SPRITE5OFFSET = #$68                     ; Norbert Bauch

SPRITE6OFFSET = #$70                    ; Kloss Mund (testweise wie Spinne)
SPRITE7OFFSET = #$78                 ; Spinne Mund


;------------------------------------------
; SPRITE-OFFSETS und anderes FÜR NEDW
;------------------------------------------


V_Sprite_00_NEDW_TOP_Offset = #$50                   ;  Erster Buchstabe "NORBERT"

V_Sprite_00_NEDW_bottom_Offset = #$57                   ; Erster Buchstave "erklärt die Welt"

V_Sprite_Y_TOP = $76            ; y-Position für Top-Sprites (Norbert)
V_Sprite_Y_bottom = $a8         ; y-Position für Bottom-Sprites (erklärt die Welt)



