


; Standard IRQs EINRICHTEN

SR:INIT_STANDARD_IRQS

#region
          sei                      ;IRQs sperren
          lda            #<MyIRQ:  ;Adresse unserer Routine in
          sta            $0314     ;den RAM-Vektor
          lda            #>MyIRQ:
          sta            $0315
          lda            #%00000001;Raster-IRQs vom VIC-II aktivieren
          sta            $D01A
          lda            #V_RASTER   ;Hier soll unsere Linie erscheinen
          sta            $D012
          lda            $D011     ;Zur Sicherheit höchstes BIT
          and            #%01111111;für die Rasterzeile löschen
          sta            $D011
          lda            #%01111111;Timer-IRQs abschalten
          sta            $DC0D
          lda            $DC0D     ;zur Sicherheit bestätigen
          lda            #%00000001;Sicherheitshalber auch den
          sta            $D019     ;Raster-IRQ bestätigen
          cli                      ;Interrupts erlauben

          rts
#endregion




SR:INIT_NEDW_IRQ

    sei                      ;IRQs sperren
          lda            #<IR:NEDW_IRQ_01  ;Adresse unserer Routine in
          sta            $0314     ;den RAM-Vektor
          lda            #>IR:NEDW_IRQ_01
          sta            $0315
          lda            #%00000001;Raster-IRQs vom VIC-II aktivieren
          sta            $D01A
          lda            #V_RASTER_NEDW_1   ;Hier soll unsere Linie erscheinen
          sta            $D012
          lda            $D011     ;Zur Sicherheit höchstes BIT
          and            #%01111111;für die Rasterzeile löschen
          sta            $D011
          lda            #%01111111;Timer-IRQs abschalten
          sta            $DC0D
          lda            $DC0D     ;zur Sicherheit bestätigen
          lda            #%00000001;Sicherheitshalber auch den
          sta            $D019     ;Raster-IRQ bestätigen
          cli                      ;Interrupts erlauben

          rts