;incasm "Variablen.asm"
;;*=$c000



;*=$2000

;incasm "interrupt01.asm"

;incasm "interrupt02.asm"


;incasm "interrupt03.asm"

;;*=$c000
;;incasm "Horst explodiert"


;*=$0801
;          BYTE           $0B,$08,$DE,$07,$9E," 2062",$00,$00,$00 ;  BASCIZEILE 2014  SYS   2062
;;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;;OO                                                                     OO
;;OO                                                                     OO
;;OO                          INIT                                       OO
;;OO                                                                     OO
;;OO                                                                     OO
;;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;#region
;main

;;************************************
;;*       VIC BANK UMSCHALTEN      ***
;;************************************
;#region
;          lda            #%00000011;Datenrichtung für BIT 0 & 1 des Port-A
;          sta            $DD02     ;zum Schreiben freigeben
;          lda            #%00000010;Bank-1
;          sta            $DD00     ;auswählen
;#endregion

;;*****************************************
;;*       Animations Register init      ***
;;*****************************************

;#region
;          lda            #00
;          sta            DELAY_COUNT_Norbert; Verzögerungszähler auf Start
;          sta            OPEN_CLOSE_FLAG_Norbert; Flag = 0 also Auge = zu
;          sta            BLINK_COUNT_Kloss; verzögerung für Blinken auf Start
;          sta            BLINK_COUNT_Spinne
;          sta            BLINK_COUNT_Horst
;          sta            DELAY_COUNT_Cursor; Verzögerung Cursor auf Start
;          sta            ON_OFF_FLAG_Cursor
;          sta            DELAY_COUNT_MUND
;   
;            
; 
;          lda            #01
;          sta            OPEN_CLOSE_FLAG_Kloss; =1, weil Auge anfangs offen
;          sta            OPEN_CLOSE_FLAG_Spinne
;          sta            OPEN_CLOSE_FLAG_Horst

;          lda $CB                     ;Tastatur in Speicher
;          sta TASTATURSPEICHER      

;#endregion
;;************************************
;;*       Bitmap zeigen            ***
;;************************************
;#region
;;***Bitmap-Modus aktivieren
;          lda           $D011     ;VIC-II Register 17 in den Akku
;          ora            #%00100000;Bitmap-Modus
;          sta            $D011     ;aktivieren
;          lda            $D016     ;VIC-II Register 22 in den Akku
;          ora            #%00010000;Multi-Color über BIT-4
;          sta            $D016     ;aktivieren
;                                   ;*** Start des Bitmapspeichers festlegen
;          lda            $D018     ;VIC-II Register 24 in den Akku holen
;          and            #%11110111;Mit BIT-3
;          ora            #VICBITMAPBBLOCKNO*8;den Beginn des
;          sta            $D018     ;Bitmapspeichers festlegen
;          jsr            showKoala ;Koala-Bild anzeigen
;          jmp            *         ;Endlosschleife
;;*** Unkomprimiertes Koalabild anzeigen
;;*** Offset (hex): Inhalt
;;*** 0000 - 1F3F : Bitmap 8000 Bytes
;;*** 1F40 - 2327 : Bildschirmspeicher 1000 Bytes
;;*** 2328 - 270F : Farb-RAM 1000 Bytes
;;*** 2710        : Hintergrundfarbe 1 Byte
;showKoala
;          ldx            #$00
;@soop
;          lda            VICBITMAPADR+$1F40,X;Farbe für Bildschirm-Speicher lesen
;          sta            VICSCREENRAM,X;und schreiben
;          lda            VICBITMAPADR+$2328,X;Farbe für COLOR-RAM lesen
;          sta            VICCOLORRAM,X;und schreiben
;          lda            VICBITMAPADR+$2040,X;für die nächsten drei Pages wiederholen
;          sta            VICSCREENRAM+256,X
;          lda            VICBITMAPADR+$2428,X
;          sta            VICCOLORRAM+256,X
;          lda            VICBITMAPADR+$2140,X
;          sta            VICSCREENRAM+512,X
;          lda            VICBITMAPADR+$2528,X
;          sta            VICCOLORRAM+512,X
;          lda            VICBITMAPADR+$2240,X
;          sta            VICSCREENRAM+768,X
;          lda            VICBITMAPADR+$2628,X
;          sta            VICCOLORRAM+768,X
;          dex                      ;Schleifenzähler verringern
;          bne            @soop     ;solange ungleich 0 -> @loop
;          lda            #$00
;          sta            $D021     ;Hintergrundfarbe setzen
;#endregion


;;_____________________________   SPRITES ANZEIGEN
;#region
;          ldx            SPRITE0OFFSET
;          stx            SPRITE0DATA;In der zuständigen Speicherstelle ablegen
;          ldx            SPRITE1OFFSET;(ldx mit 8, da die 8 Sprites1 8 hinter den 8 von Sprite 0 beginnen)
;          stx            SPRITE1DATA;und dem VIC II mitteilen
;          ldx            SPRITE2OFFSET
;          stx            SPRITE2DATA
;          ldx            SPRITE3OFFSET
;          stx            SPRITE3DATA
;          ldx            SPRITE6OFFSET
;          stx            SPRITE6DATA
;          ldx            SPRITE7OFFSET
;          stx            SPRITE7DATA


;          lda            #%00000000;Keine Vergrößerung gewünscht
;          sta            SPRITEDOUBLEHEIGHT;doppelte Höhe zurücksetzen
;          sta            SPRITEDOUBLEWIDTH;doppelte Breite zurücksetzen
;          lda            #%00001111;Sprite 0-3 Multicolor
;          sta            SPRITEMULTICOLOR;Multicolor für alle Sprites aktivieren
;          lda            #%00000000;Alle vor Background
;          sta            SPRITEDEEP
;          lda            #$0f      ;Hellgrau = Farbe für
;          sta            SPRITE0COLOR;Sprite-0 (hat nur eine, da Hi-Res!)
;          lda            #$0F      ;Hellgrau = Hauptfarbe für
;          sta            SPRITE1COLOR;Sprite-1 (ist Multicolor, daher Hauptfarbe!)
;          lda            #$00      ;Schwarz = Farbe für
;          sta            SPRITEMULTICOLOR0;Multicolor-0
;          lda            #$01      ;Weiss = Farbe für
;          sta            SPRITEMULTICOLOR1;Mulitcolor-1
;          lda #$00
;          sta            SPRITE6COLOR
;          lda #$00
;          sta            SPRITE7COLOR
;;***  Sprite Positionen ***
;          ldx            #%00001000; höchstes Bit für X löschen
;          stx            SPRITESMAXX;und für Sprite 3 (ganz rechts) setzen
;          ldx            #$49      ;X-Pos für
;          stx            SPRITE0X  ;Sprite-0
;          ldy            #$7f      ;Y-Position
;          sty            SPRITE0Y  ;für Sprite-0
;          ldx            #$8a      ;X-Pos für
;          stx            SPRITE1X  ;Sprite-1
;          ldy            #$84      ;Y-Position
;          sty            SPRITE1Y  ;und Sprite-1
;          ldx            #$e7      ;X-Pos für
;          stx            SPRITE2X  ;Sprite-2
;          ldy            #$80      ;Y-Position
;          sty            SPRITE2Y  ;für Sprite-2
;          ldx            #$3d      ;X-Pos für
;          stx            SPRITE3X  ;Sprite-3
;          ldy            #$81      ;Y-Position
;          sty            SPRITE3Y  ;und Sprite-3


;          ldx            #$8d      ;X-Pos für
;          stx            SPRITE6X  ;Sprite-6
;          ldy            #$8d      ;Y-Position
;          sty            SPRITE6Y  ;für Sprite-6

;          ldx            #$eb      ;X-Pos für
;          stx            SPRITE7X  ;Sprite-7
;          ldy            #$89      ;Y-Position
;          sty            SPRITE7Y  ;für Sprite-7
;; AKTIVIEREN
;          lda            #%11001111 ; 0-3 & 7
;          sta            SPRITEACTIV;aktivieren, alle anderen ausblenden
;#endregion
;                                   ;_____________________________ INTERRUPT EINRICHTEN
;#region
;          sei                      ;IRQs sperren
;          lda            #<MyIRQ:  ;Adresse unserer Routine in
;          sta            $0314     ;den RAM-Vektor
;          lda            #>MyIRQ:
;          sta            $0315
;          lda            #%00000001;Raster-IRQs vom VIC-II aktivieren
;          sta            $D01A
;          lda            #RASTER   ;Hier soll unsere Linie erscheinen
;          sta            $D012
;          lda            $D011     ;Zur Sicherheit höchstes BIT
;          and            #%01111111;für die Rasterzeile löschen
;          sta            $D011
;          lda            #%01111111;Timer-IRQs abschalten
;          sta            $DC0D
;          lda            $DC0D     ;zur Sicherheit bestätigen
;          lda            #%00000001;Sicherheitshalber auch den
;          sta            $D019     ;Raster-IRQ bestätigen
;          cli                      ;Interrupts erlauben
;#endregion
;#endregion
;;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;;OO                                                                     OO
;;OO                                                                     OO
;;OO                          HAUPTPROGRAMM                              OO
;;OO                                                                     OO
;;OO                                                                     OO
;;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

;#region
; 
;key_wait
;    lda $CB                     ;Matrixkoordinate lesen
;    cmp TASTATURSPEICHER       ; hat sich etwas verändert?
;    beq key_wait                 ; nö? weiter warten!



;    cmp #$40                    ;besteht die änderung darin, dass
;                                ;jetzt keine Taste mehr gedrückt ist?
;    
;    beq MUND_ANIMATION          ; ja? Alles läuft weiter wie bisher
;  
;    
;    sta TASTATURSPEICHER        ; nein? D.h. es wurde gedrückt-> Speicher aktualisieren
;    
;    lda SPRITE6OFFSET           ; Münder auf Anfangswert
;    sta SPRITE6DATA 
;    lda SPRITE7OFFSET
;    sta SPRITE7DATA 

;MUND_ANIMATION
;   
;    lda TASTATURSPEICHER
;    cmp #$0D                    ;wurde S gedrückt?
;    beq SPINNE_SPRICHT          ; ja - > Spinne talking
;    cmp #$25                    ;wurde K gedrückt?
;    beq KLOSS_SPRICHT 
;    cmp #$1D                    ; H?
;    beq EXPLODIER
;    

; jmp key_wait

;SPINNE_SPRICHT

;   
; jsr GET_RND:

;        and #%00000111           ;Zufallswert zwischn 0 und 7
;        sbc #01
;        adc SPRITE7OFFSET        ; addiere diesen als offset zum Startwert des Spriteblockes      
;        sta SPRITE7DATA         ; speichere das Ergebins im Sprite 7 pointer
;        jmp checkdelaycount



;KLOSS_SPRICHT


; jsr GET_RND:

;        and #%00000111           ;Zufallswert zwischn 0 und 2 hoch 3=8
;        sbc #01
;        adc SPRITE6OFFSET        ; addiere diesen als offset zum Startwert des Spriteblockes      
;        sta SPRITE6DATA         ; speichere das Ergebins im Sprite 7 pointer
;        jmp checkdelaycount


;checkdelaycount
;           
;           lda  DELAY_COUNT_MUND 
;           cmp#$04
;           bne checkdelaycount ; noch nicht abgelaufen? Schleife!

; 
; lda #$00
; 
; sta DELAY_COUNT_MUND      ; Verzögerung für nächste Animphase auf 0
; 
; jmp key_wait              ;falls nicht -> @wait

;GET_RND:                           ;Subroutine Zufallszahl von den Timern
;          lda            $DC04     ;Low-Byte  von Timer A aus dem CIA-1
;          eor            $DC05     ;High-Byte von Timer A aus dem CIA-1
;          eor            $DD04     ;Low-Byte  von Timer A aus dem CIA-2
;          adc            $DD05     ;High-Byte von Timer A aus dem CIA-2
;          eor            $DD06     ;Low-Byte  von Timer B aus dem CIA-2
;          eor            $DD07     ;High-Byte von Timer B aus dem CIA-2
;         
;          rts


;  
;@wait 

; lda $CB
; cmp #$40
; beq @wait



;EXPLODIER


; lda            #$01
;          sta            $D021     ;Hintergrundfarbe setzen#


;          sta            $D020    ;Hintergrundfarbe setzen

;#region


; 


; ldx #00

;@SHAPE_loop
; lda shape01_in,x 
; sta shape01_out,x
; 
; lda shape01_in+ $140,x 
; sta shape01_out + $140,x
; 
; lda shape01_in + $280,x 
; sta shape01_out + $280,x

; 
; lda shape01_in + $3c0,x 
; sta shape01_out + $3c0,x 

; lda shape01_in + $500,x 
; sta shape01_out + $500,x 

; lda shape01_in + $640,x 
; sta shape01_out + $640,x 

; lda shape01_in + $780,x 
; sta shape01_out + $780,x 

; inx
; cpx #$40
; bne @SHAPE_loop

; ldx #0

;@COLOR_loop

; lda            shape1_c1_in,X
; sta            shape1_c1_out,X
; lda            shape1_c2_in,x
; sta            shape1_c2_out,X

; lda            shape1_c1_in +40 ,X
; sta            shape1_c1_out+40,X
; lda            shape1_c2_in+40,x
; sta            shape1_c2_out+40,X

; lda            shape1_c1_in+80,X
; sta            shape1_c1_out+80,X
; lda            shape1_c2_in+80,X
; sta            shape1_c2_out+80,X

; lda            shape1_c1_in+120,X
; sta            shape1_c1_out+120,X
; lda            shape1_c2_in+120,X
; sta            shape1_c2_out+120,x

; lda            shape1_c1_in+160,X
; sta            shape1_c1_out+160,X
; lda            shape1_c2_in+160,X
; sta            shape1_c2_out+160,X

; lda            shape1_c1_in+200,X
; sta            shape1_c1_out+200,X
; lda            shape1_c2_in+200,X
; sta            shape1_c2_out+200,X

; lda            shape1_c1_in+240,X
; sta            shape1_c1_out+240,X
; lda            shape1_c2_in+240,X
; sta            shape1_c2_out+240,X

; inx 
; cpx #$08
; bne @COLOR_loop

;#endregion




; jsr SUBVERZ

; lda            #$00
;          sta            $D021     ;Hintergrundfarbe setzen
;  sta            $D020    ;Hintergrundfarbe setzen

;PLOT_SHAPE_02

;#region



; ldx #00

;@SHAPE_loop2
; lda shape01_in+$40,x 
; sta shape01_out,x
; 
; lda shape01_in+ $180,x 
; sta shape01_out + $140,x
; 
; lda shape01_in + $2c0,x 
; sta shape01_out + $280,x

; 
; lda shape01_in + $400,x 
; sta shape01_out + $3c0,x 

; lda shape01_in + $540,x 
; sta shape01_out + $500,x 

; lda shape01_in + $680,x 
; sta shape01_out + $640,x 

; lda shape01_in + $7c0,x 
; sta shape01_out + $780,x 

; inx
; cpx #$40
; bne @SHAPE_loop2



; ldx #00

;@COLOR_loop2


; lda            shape1_c1_in+8,X
; sta            shape1_c1_out,X
; lda            shape1_c2_in+8,x
; sta            shape1_c2_out,X

; lda            shape1_c1_in +48 ,X
; sta            shape1_c1_out+40,X
; lda            shape1_c2_in+48,x
; sta            shape1_c2_out+40,X

; lda            shape1_c1_in+88,X
; sta            shape1_c1_out+80,X
; lda            shape1_c2_in+88,X
; sta            shape1_c2_out+80,X

; lda            shape1_c1_in+128,X
; sta            shape1_c1_out+120,X
; lda            shape1_c2_in+128,X
; sta            shape1_c2_out+120,x

; lda            shape1_c1_in+168,X
; sta            shape1_c1_out+160,X
; lda            shape1_c2_in+168,X
; sta            shape1_c2_out+160,X

; lda            shape1_c1_in+208,X
; sta            shape1_c1_out+200,X
; lda            shape1_c2_in+208,X
; sta            shape1_c2_out+200,X

; lda            shape1_c1_in+248,X
; sta            shape1_c1_out+240,X
; lda            shape1_c2_in+248,X
; sta            shape1_c2_out+240,X

; inx 
; cpx #$08
; bne @COLOR_loop2


;#endregion


; jsr SUBVERZ




;PLOT_SHAPE_03

;#region


;PLOT_SHAPE_3
; ldx #00

;@SHAPE_loop3
; lda shape01_in+$80,x 
; sta shape01_out,x
; 
; lda shape01_in+ $1c0,x 
; sta shape01_out + $140,x
; 
; lda shape01_in + $300,x 
; sta shape01_out + $280,x

; 
; lda shape01_in + $440,x 
; sta shape01_out + $3c0,x 

; lda shape01_in + $580,x 
; sta shape01_out + $500,x 

; lda shape01_in + $6c0,x 
; sta shape01_out + $640,x 

; lda shape01_in + $800,x 
; sta shape01_out + $780,x 

; inx
; cpx #$40
; bne @SHAPE_loop3



; ldx #0

;@COLOR_loop3

; lda            shape1_c1_in+16,X
; sta            shape1_c1_out,X
; lda            shape1_c2_in+16,x
; sta            shape1_c2_out,X

; lda            shape1_c1_in +56 ,X
; sta            shape1_c1_out+40,X
; lda            shape1_c2_in+56,x
; sta            shape1_c2_out+40,X

; lda            shape1_c1_in+96,X
; sta            shape1_c1_out+80,X
; lda            shape1_c2_in+96,X
; sta            shape1_c2_out+80,X

; lda            shape1_c1_in+136,X
; sta            shape1_c1_out+120,X
; lda            shape1_c2_in+136,X
; sta            shape1_c2_out+120,x

; lda            shape1_c1_in+176,X
; sta            shape1_c1_out+160,X
; lda            shape1_c2_in+176,X
; sta            shape1_c2_out+160,X

; lda            shape1_c1_in+216,X
; sta            shape1_c1_out+200,X
; lda            shape1_c2_in+216,X
; sta            shape1_c2_out+200,X

; lda            shape1_c1_in+256,X
; sta            shape1_c1_out+240,X
; lda            shape1_c2_in+256,X
; sta            shape1_c2_out+240,X

; 


; inx 
; cpx #$08
; bne @COLOR_loop3








;#endregion



; jsr SUBVERZ


;PLOT_SHAPE_04

;#region


;PLOT_SHAPE_4
; ldx #00

;@SHAPE_loop4
; lda shape01_in+$c0,x 
; sta shape01_out,x
; 
; lda shape01_in+ $200,x 
; sta shape01_out + $140,x
; 
; lda shape01_in + $340,x 
; sta shape01_out + $280,x

; 
; lda shape01_in + $480,x 
; sta shape01_out + $3c0,x 

; lda shape01_in + $5c0,x 
; sta shape01_out + $500,x 

; lda shape01_in + $700,x 
; sta shape01_out + $640,x 

; lda shape01_in + $840,x 
; sta shape01_out + $780,x 

; inx
; cpx #$40
; bne @SHAPE_loop4



; ldx #0

;@COLOR_loop4

; lda            shape1_c1_in+$18,X
; sta            shape1_c1_out,X
; lda            shape1_c2_in+$18,x
; sta            shape1_c2_out,X

; lda            shape1_c1_in +$40 ,X
; sta            shape1_c1_out+40,X
; lda            shape1_c2_in+$40,x
; sta            shape1_c2_out+40,X

; lda            shape1_c1_in+$68,X
; sta            shape1_c1_out+80,X
; lda            shape1_c2_in+$68,X
; sta            shape1_c2_out+80,X

; lda            shape1_c1_in+$90,X
; sta            shape1_c1_out+120,X
; lda            shape1_c2_in+$90,X
; sta            shape1_c2_out+120,x

; lda            shape1_c1_in+$b8,X
; sta            shape1_c1_out+160,X
; lda            shape1_c2_in+$b8,X
; sta            shape1_c2_out+160,X

; lda            shape1_c1_in+$e0,X
; sta            shape1_c1_out+200,X
; lda            shape1_c2_in+$e0,X
; sta            shape1_c2_out+200,X

; lda            shape1_c1_in+$108,X
; sta            shape1_c1_out+240,X
; lda            shape1_c2_in+$108,X
; sta            shape1_c2_out+240,X

; 


; inx 
; cpx #$08
; bne @COLOR_loop4




;#endregion


;LOT_SHAPE_05

;#region


;PLOT_SHAPE_5
; ldx #00

;@SHAPE_loop5
; lda shape01_in+$100,x 
; sta shape01_out,x
; 
; lda shape01_in+ $240,x 
; sta shape01_out + $140,x
; 
; lda shape01_in + $380,x 
; sta shape01_out + $280,x

; 
; lda shape01_in + $4c0,x 
; sta shape01_out + $3c0,x 

; lda shape01_in + $600,x 
; sta shape01_out + $500,x 

; lda shape01_in + $740,x 
; sta shape01_out + $640,x 

; lda shape01_in + $880,x 
; sta shape01_out + $780,x 

; inx
; cpx #$40
; bne @SHAPE_loop5



; ldx #0

;@COLOR_loop5

; lda            shape1_c1_in+$20,X
; sta            shape1_c1_out,X
; lda            shape1_c2_in+$20,x
; sta            shape1_c2_out,X

; lda            shape1_c1_in +$48 ,X
; sta            shape1_c1_out+40,X
; lda            shape1_c2_in+$48,x
; sta            shape1_c2_out+40,X

; lda            shape1_c1_in+$70,X
; sta            shape1_c1_out+80,X
; lda            shape1_c2_in+$70,X
; sta            shape1_c2_out+80,X

; lda            shape1_c1_in+$98,X
; sta            shape1_c1_out+120,X
; lda            shape1_c2_in+$98,X
; sta            shape1_c2_out+120,x

; lda            shape1_c1_in+$c0,X
; sta            shape1_c1_out+160,X
; lda            shape1_c2_in+$c0,X
; sta            shape1_c2_out+160,X

; lda            shape1_c1_in+$e8,X
; sta            shape1_c1_out+200,X
; lda            shape1_c2_in+$e8,X
; sta            shape1_c2_out+200,X

; lda            shape1_c1_in+$110,X
; sta            shape1_c1_out+240,X
; lda            shape1_c2_in+$110,X
; sta            shape1_c2_out+240,X

; 


; inx 
; cpx #$08
; bne @COLOR_loop5



; jmp key_wait




;#endregion


; rts

;SUBVERZ
; ldy #$00
;Verz256
; ldx #00
;Verz
; 
; inx
; cpx #$ff
; bne Verz
; iny
; cpy #$28
; bne Verz256
; rts
;  

;#endregion



;;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;;OO                                                                     OO
;;OO                                                                     OO
;;OO                      DATEN                                          OO
;;OO                                                                     OO
;;OO                                                                     OO
;;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;#region
;;*************************   BILD LADEN
;*=$6000                       ;das Prg Studio mag hier keine Konstanten!!!
;incbin    "spin04.koa",2        ;Bild einbinden
;;************************  SPRITE DATEN LADEN
;*=$5000           ;SPRITE DATEN ab 5000

;incbin    "Sprites01.bin",2

;;*************************   BILD 2LADEN
;*=$a000                       ;das Prg Studio mag hier keine Konstanten!!!
;incbin    "shapestest2.koa",2






;#endregion
