incasm    "Variablen.asm"



*=$0801
          BYTE           $0B,$08,$DE,$07,$9E," 2062",$00,$00,$00 
;  BASCIZEILE 2014  SYS   2062

;-----------------------------------------
; TExt ausgeben
;------------------------------------------
R:OUTPUT_TEXT
          clc
;*** Lesezeichen in die Zero-Page
          lda            #<M_Textstart
          sta            MZ_Lesezeichen_Zero
          lda            #>M_Textstart
          sta            MZ_Lesezeichen_Zero+1
          ldy            #$01      ;Nächstes Zeichen in X (0 = erstes)
         
R:LESE_LOOP
          
          lda            (MZ_Lesezeichen_Zero),y;Zeichen in den Akku
          cmp            K_Text_Ende ; Textendebyte?
          beq            R:END_OF_TEXT
          cmp            K_Textblock_Ende ; Textblockende?
          beq            R:NEXT_TEXT_BLOCK ; -> nächster Textblock
          cpy            K_Textfenster   ; Textfenster voll?
          beq            R:NEXT_TEXT_BLOCK ; -> nächster Textblock
          sta            $03ff,y   ;Zeichen ausgeben
          iny                      ;Position für nächstes Zeichen erhöhen
          jmp            R:LESE_LOOP;nochmal


;-----------------------------------------
;  Nächster Textblock zwischen 2 mal @
;------------------------------------------


R:NEXT_TEXT_BLOCK
; nöchster textblock
 
                jsr            SR:WAIT_FOR_KEY
                jsr SR:CLEARSCREEN
                tya                      ; zähler in akku (rechenvorbereitung)
                ldy            #$01
                adc            MZ_Lesezeichen_Zero; lesezeichen dazu addieren 
                sta            MZ_Lesezeichen_Zero; aufsummiertes kesezeichen speichern
               
                bcs          R:NEXT_PAGE; überlauf? lesezeichen um 256 erhögen

;R:BACK_FROM_NEXT_PAGE  ; Einsprung nach "Umblättern"
                   
                 jmp            R:LESE_LOOP



;-----------------------------------------
;  Nächste "Seite" - höherwertiges Lesezeichenbyte um 1 erhöhen
;------------------------------------------

R:NEXT_PAGE
         inc            MZ_Lesezeichen_Zero+1
  lda#$01          
 
  sta            $d020
          clc
; iny
         
          jmp            R:LESE_LOOP



;-----------------------------------------
;  Textende -> Neustart
;------------------------------------------
R:END_OF_TEXT
          lda            #<M_Textstart; alles auf Anfang
          sta            MZ_Lesezeichen_Zero
          lda            #>M_Textstart+1
          sta            MZ_Lesezeichen_Zero+1
          jmp            R:OUTPUT_TEXT



align     1024
SR:WAIT_FOR_KEY
          lda            $cb
          sta            M_Tastaturspeicher
R:WAIT_FOR_KEY
          lda            $CB       ;Matrixkoordinate lesen
          cmp            M_Tastaturspeicher;noch immer selbe Taste gedrückt?
          beq            R:WAIT_FOR_KEY; ja? weiter warten!
          cmp            #$40      ;besteht die änderung darin, dass
                                   ;jetzt keine Taste mehr gedrückt ist?
          beq            R:WAIT_FOR_KEY; ja? Weiter warten!

          rts


SR:CLEARSCREEN
 ldx #$00
 lda #32
R:CLEARSCREENLOOP
 sta $0400,x
 inx 
 bne R:CLEARSCREENLOOP
 rts




;-----------------------------------------
; TEXT
;------------------------------------------
*=$9800
          text           'Schnorbert: Brause hamwer nich, Schnaps    '
          text           'kannste ham!                           '
          text           'Spinne: Oh, hihi@'
          text           'abcdefg                                 '
          text           'qwertzuiop@'
      text           '                                       @'
         
          text           'Es dauerte nicht lange, dann hatten wir uns mit ihr angefreundet. Wir kauften ein, Frau Becker revanchiert sich mit Zitronenkuchen, Kapernklopsen und ihrer Lebensgeschichte. 87 Jahre in Berlin Prenzlauer Berg. Sie war vier Jahre alt, als Hitler an die Macht kam,  16 als der Krieg endete. Mit 32 Jahren erlebte sie den Mauerbau, mit 60 den Mauerfall. Als 72jaehrige sah sie im Fernsehn die Zwillingstuerme brennen, und jetzt brennt ihr der Geburtstagkuchen an. Sie kann sich noch alleine anziehen und waschen, doch was ist das fuer ein Trost, wenn sie keinen Kuchen mehr backen kann? '
          byte           $ff
; text '                                        '
     
          byte           $ff
                                   ;Textend