
#region
align     1024
MyIRQ:



          lda            #$0e     ;
          sta            $D020    ;Rahmenfarbe für IRQ setzen
 

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      INTERRUPT 1:   SPLITSCREEN                     OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

R:SPLITSCREEN

 ;-----------------------------------------
; Spritedaten aus dem Kneipen-Screen saven
;-----------------------------------------

 lda SPRITE0DATA
          sta M_SPRITE0DATA
  lda SPRITE1DATA
          sta M_SPRITE1DATA
 lda SPRITE2DATA
          sta M_SPRITE2DATA
 lda SPRITE3DATA
          sta M_SPRITE3DATA
  lda SPRITE4DATA
          sta M_SPRITE4DATA
 lda SPRITE5DATA
          sta M_SPRITE5DATA
  lda SPRITE6DATA
          sta M_SPRITE6DATA
  lda SPRITE7DATA
          sta M_SPRITE7DATA



 lda F_Sprecher
 bne R:SPRECHBLASEN

R:KEINE_SPRECHBLASEN
    lda            #%00000000 ; alle Sprites
    sta            SPRITEACTIV;deaktivieren
  jsr SR:CLEARSCREEN ; oberen Grafik-Colorram mit hellgrau füllen
    jmp R:IRQ_TEXTFENSTER_ENDE

R:SPRECHBLASEN

;-----------------------------------------
; VIC-BANK 0 (0-4000)
;------------------------------------------
#region
          lda            #%00000011;Datenrichtung für BIT 0 & 1 des Port-A
          sta            $DD02     ;zum Schreiben freigeben
          lda            #%00000010;Bank-1 (ist so: 11 wählt bank 0!)
          sta            $DD00     ;auswählen
#endregion


          
         
          lda  M_Standard_Farbe_Texthintergrund
          sta            $D021
;-----------------------------------------
; TEXTMODUS AKTIVIREN
;------------------------------------------
   
      lda           $D011     ;VIC-II Register 17 in den Akku
      and          #%11011111 ;Bitmap-Modus aus
      sta            $D011     ;deaktivieren

 lda 23
 sta 53272
   
TVICBANKNO               = 0                             ;Nr. (0 - 3) der 16KB Bank                              | Standard: 0
TVICSCREENBLOCKNO        = 1                             ;Nr. (0 -15) des 1KB-Blocks für den Textbildschirm      | Standard: 1
TVICCHARSETBLOCKNO       = 1                             ;Nr. (0 - 7) des 2KB-Blocks für den Zeichensatz         | Standard: 2
TVICBITMAPBBLOCKNO       = 0                             ;Nr. (0 - 1) des 8KB-Blocks für die BITMAP-Grafik       | Standard: 0
TVICBASEADR              = TVICBANKNO*16384               ;Startadresse der gewählten VIC-Bank                    | Standard: $0000
TVICCHARSETADR           = TVICCHARSETBLOCKNO*2048        ;Adresse des Zeichensatzes                              | Standard: $1000 ($D000)
TVICCHARSETADR           = TVICCHARSETADR+VICBASEADR
 

DUMMY=TVICSCREENBLOCKNO*16
DUMMY2=TVICCHARSETBLOCKNO*2
 lda #DUMMY+DUMMY2
 sta $D018          




;-----------------------------------------
; Spritedaten für Sprechblase setzen
;-----------------------------------------

  lda            #%11111111;alle Sprites Multicolor
          sta            SPRITEMULTICOLOR;Multicolor für alle Sprites aktivieren

; Spechblasenböppel
                
;sprechblasenstrich
                lda         V_Sprite_Sprechblase_4
                sta           SPRITE1DATA;In der zuständigen Speicherstelle                             ablegen
                sta           SPRITE2DATA
                sta           SPRITE3DATA

                sta           SPRITE4DATA
                sta           SPRITE5DATA
                  sta           SPRITE6DATA
                         sta           SPRITE7DATA

          ldy            #$49  ;Y-Position
          sty            SPRITE0Y  ;für Sprite-0 gilt für alle Sprechblasen
          ldy            #$49  ;Y-Position
          sty            SPRITE1Y  ;für Sprite-1 gilt für alle                                          SPRECHBLASENstriche
          sty            SPRITE2Y 
          sty            SPRITE3Y 
                sty            SPRITE4Y 
                sty            SPRITE5Y 
                sty             SPRITE6Y
                sty             SPRITE7Y



;-----------------------------------------
; Sprechblasen aktivieren
;------------------------------------------
  ldx            #%00000000; höchstes Bit für X löschen außer                                     strich 6 &7
  stx            SPRITESMAXX  
 lda F_Sprecher ; Wer spricht?
 cmp #$01    
 beq R:SPRECHBLASE_NORBERT
 cmp #$02
 beq R:SPRECHBLASE_KLOSS
 cmp #$03
 beq R:SPRECHBLASE_SPINNE
 jmp R:IRQ_TEXTFENSTER_ENDE ;!!! Falls ein anderer WErt kommt
 
 
R:SPRECHBLASE_NORBERT
         lda           V_Sprite_Sprechblase_1
                sta           SPRITE0DATA;In der zuständigen Speicherstelle                             ablegen 
 ldx #$70
          stx            SPRITE0X  ;Sprite-0
          ldy #$05
          sty SPRITE0COLOR
          jmp R:SPRECHBLASEN_AKTIVIEREN

R:SPRECHBLASE_KLOSS
        lda          V_Sprite_Sprechblase_3
         sta           SPRITE0DATA;In der zuständigen Speicherstelle                             ablegen
          ldx            #$89      ;X-Pos für
          stx            SPRITE0X  ;Sprite-0
          ldx #$0e
          stx SPRITE0COLOR

          jmp R:SPRECHBLASEN_AKTIVIEREN


R:SPRECHBLASE_SPINNE
         lda          V_Sprite_Sprechblase_2
                sta           SPRITE0DATA;In der zuständigen Speicherstelle                             ablegen
       
          ldx            #$c0      ;X-Pos für
          stx            SPRITE0X  ;Sprite-0
          ldx #$02
          stx SPRITE0COLOR
          jmp R:SPRECHBLASEN_AKTIVIEREN


R:SPRECHBLASEN_AKTIVIEREN
                ldx            #%11000000; höchstes Bit für X löschen außer                                    strich 6 &7
                stx            SPRITESMAXX
                ldx #$18
                stx SPRITE1X 
                ldx #$48
                stx SPRITE2X 
                ldx #$78
                stx SPRITE3X 
                ldx #$a8
                stx SPRITE4X 
                ldx #$d8
                stx SPRITE5X 
                ldx #$08
                stx SPRITE6X 
                ldx #$38
                stx SPRITE7X 

          lda            #%00000000; Alle einfache höhe
          sta            SPRITEDOUBLEHEIGHT
           lda #%11111110
           sta     SPRITEDOUBLEWIDTH ; strich-Sprites dooppelte breite!
          lda            #%11111111 ; Sprite 1 unsd 2
          sta            SPRITEACTIV;aktivieren, alle anderen ausblenden
        
   

R:IRQ_TEXTFENSTER_ENDE



; zweiten raster aktivieren
          lda            #<MyIRQ_1:;Adresse unserer Routine in
          sta            $0314     ;den RAM-Vektor
          lda            #>MyIRQ_1:
          sta            $0315

;________________________  Counter für Mundanimation hochzählen


      


; lda #%00000001                 ;Raster-IRQs vom VIC-II aktivieren
; sta $D01A
          lda            #V_RASTER_1 ;Hier soll unsere Linie erscheinen
          sta            $D012
         lda            M_Standard_Farbe_Rahmen

          sta            $D020    ; Hintergrund wieder schwarz

             
          lda            #%00000001;IRQ bestätigen
          sta            $D019
          jmp            $EA31     ;zum Schluß zum 'Timer-Interrupt' springe
#endregion