;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      INTERRUPT 2:   Animationen und Bitmap          OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
#region
align     1024
MyIRQ_2:
         lda #$07

     sta            $D020     ;Rahmenfarbe setzen



        lda M_SPRITE0DATA ; Sprites resetten für Mund und Augen
        sta SPRITE0DATA
         lda M_SPRITE1DATA ; Sprites resetten für Mund und Augen
        sta SPRITE1DATA
   lda M_SPRITE2DATA 
        sta SPRITE2DATA
   lda M_SPRITE3DATA ; Sprites resetten für Mund und Augen
        sta SPRITE3DATA
   lda M_SPRITE4DATA ; Sprites resetten für Mund und Augen
        sta SPRITE4DATA
   lda M_SPRITE5DATA ; Sprites resetten für Mund und Augen
        sta SPRITE5DATA
   lda M_SPRITE6DATA ; Sprites resetten für Mund und Augen
        sta SPRITE6DATA
   lda M_SPRITE7DATA ; Sprites resetten für Mund und Augen
        sta SPRITE7DATA




          lda            #%00100000; NORBERTs Bauch doppelte Höhe
          sta            SPRITEDOUBLEHEIGHT;doppelte Höhe zurücksetzen

          lda            #%00000000 ;einfache Breite für alle Sprites
          sta            SPRITEDOUBLEWIDTH;doppelte Breite zurücksetzen
          lda            #%00111111;Sprite 0-3 Multicolor
          sta            SPRITEMULTICOLOR;Multicolor für alle Sprites aktivieren
        
          lda            #$0f      ;Hellgrau = Farbe für
          sta            SPRITE0COLOR;Sprite-0 (hat nur eine, da Hi-Res!)
          lda            #$0F      ;Hellgrau = Hauptfarbe für
          sta            SPRITE1COLOR;Sprite-1 (ist Multicolor, daher Hauptfarbe!)
          sta            SPRITE2COLOR
          sta            SPRITE3COLOR





          lda            #$00      ;Schwarz = Farbe für
          sta            SPRITEMULTICOLOR0;Multicolor-0
          lda            #$01      ;Weiss = Farbe für
          sta            SPRITEMULTICOLOR1;Mulitcolor-1

 lda #$0a 
          sta            SPRITE4COLOR

 lda #$05
          sta            SPRITE5COLOR



          lda #$00
          sta            SPRITE6COLOR
          lda #$00
          sta            SPRITE7COLOR

;???????????????????????????????????????????????????????????????????????????

 ldx            #%00001000; höchstes Bit für X löschen
          stx            SPRITESMAXX;und für Sprite 3 (ganz rechts) setzen
          ldx            #$49      ;X-Pos für
          stx            SPRITE0X  ;Sprite-0
          ldy            #$8e  ;Y-Position
          sty            SPRITE0Y  ;für Sprite-0
          ldx            #$8a      ;X-Pos für
          stx            SPRITE1X  ;Sprite-1
          ldy            #$92   ;Y-Position
          sty            SPRITE1Y  ;und Sprite-1
          ldx            #$e7      ;X-Pos für
          stx            SPRITE2X  ;Sprite-2
          ldy            #$8f     ;Y-Position
          sty            SPRITE2Y  ;für Sprite-2
          ldx            #$3d      ;X-Pos für
          stx            SPRITE3X  ;Sprite-3
          ldy            #$90     ;Y-Position
          sty            SPRITE3Y  ;und Sprite-3
 
; Norberts Mund  Position 

          ldx            #$48      ;X-Pos für
          stx            SPRITE4X  ;Sprite-2
          ldy            #$91   ;Y-Position
          sty            SPRITE4Y  ;für Sprite-2

; Norberts Bauch  Position     
          ldx            #$4e      ;X-Pos für
          stx            SPRITE5X  ;Sprite-3
          ldy            #$bd     ;Y-Position
          sty            SPRITE5Y  ;und Sprite-3


          ldx            #$8d      ;X-Pos für
          stx            SPRITE6X  ;Sprite-6
          ldy            #$9c      ;Y-Position
          sty            SPRITE6Y  ;für Sprite-6

          ldx            #$eb      ;X-Pos für
          stx            SPRITE7X  ;Sprite-7
          ldy            #$98    ;Y-Position
          sty            SPRITE7Y  ;für Sprite-7
;LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL

;; AKTIVIEREN
          lda F_Horst_schon_explodiert
          beq R:MIT_HORST
          
;R:OHNE HORST
          lda            #%11110111 ; 0-3 & 7
          sta            SPRITEACTIV;aktivieren, alle anderen ausblenden
          jmp BLINK_INITIAL:



R:MIT_HORST
          lda            #%11111111 ; 0-3 & 7
          sta            SPRITEACTIV;aktivieren, alle anderen ausblenden
          jmp BLINK_INITIAL:




; ######################################################################




;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      INTERRUPT 2: AUGENZWINKERN                     OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

 
;-----------------------------------------
; Wer zwinkert? Zufallsauswahl BLINK_INITIAL:
;------------------------------------------

#region
BLINK_INITIAL:
          jsr            SR:GET_RND
          cmp            K_Ausloeser_Kloss;mit Kloßens Zahl vergleichen
          beq            KLOSS_BLINK:; Ja? -> Kloß blinzelt!
          cmp            K_Ausloeser_Kloss+1;doppelte chance!
          beq            KLOSS_BLINK:; Ja? -> Kloß blinzelt!
          cmp            K_Ausloeser_Kloss+2;dreifache chance!
          beq            KLOSS_BLINK:; Ja? -> Kloß blinzelt!
          cmp            K_Ausloeser_Spinne;mit Spinnes Zahl vergleichen
          beq            Spinne_BLINK:; Ja? -> Spinne blinzelt!
          cmp            K_Ausloeser_Spinne+1;mit Spinnes Zahl vergleichen
          beq            Spinne_BLINK:; Ja? -> Spinne blinzelt!
          cmp            K_Ausloeser_Horst;mit Horsts Zahl vergleichen
          beq            HORST_BLINK:; Ja? -> Horsts blinzelt!
          jmp            Kloss_Auge_wieder_oeffnen:; Alles Nieten? Augen auf oder Ende der Routine
#endregion
;-----------------------------------------
;  KLOSS BLINZELT
;-----------------------------------------
#region
KLOSS_BLINK:
          lda            F_Eyes_open_Kloss;Kloß Augen Flag laden
          cmp            #00    ; Auge zu? (0=Auge zu, 1 Auge auf, Startwert 1)
          beq            Kloss_Auge_wieder_oeffnen:; ja -> weiter zu Kloss_Auge_oeffnen:
                                   ; wenn nicht: Auge schliessen
;_____Kloss auge schliessen
Kloss_Auge_schliessen:
          ldx            SPRITE1OFFSET_AUGE_ZU
          stx            SPRITE1DATA
          lda            #00
          sta            F_Eyes_open_Kloss; Status auf "Auge zu"
          sta            C_Delay_Zwinkern_Kloss; Verzögerungszähler auf 0 - > Start
          jmp            Kloss_Auge_wieder_oeffnen:
#endregion
;-----------------------------------------
; Spinne BLINZEL AN
;-----------------------------------------
#region
SPINNE_BLINK:
          lda            F_Eyes_open_Spinne;Spinne Augen Flag laden
          cmp            #00       ; Auge zu? (0=Auge zu, 1 Auge auf, Startwert 1)
          beq            Spinne_Auge_oeffnen:; ja -> weiter zu Kloss_Auge_oeffnen:
; wenn nicht: Auge schliessen
;_____Spinne auge schliessen
Spinne_Auge_schliessen:
          ldx            SPRITE2DATA;lade Wert aus Spritepointer für Sprite 1
          inx                      ; (+1 = nächstern Spritedatenblock=KLoss Auge zu)
          stx            SPRITE2DATA
          lda            #00
          sta            F_Eyes_open_Spinne; Status auf "Auge zu"
          sta            C_Delay_Zwinkern_Spinne; Verzögerungszähler auf 0 - > Start
          jmp            Kloss_Auge_wieder_oeffnen:
#endregion
;-----------------------------------------
;Horst BLINZEL AN
;-----------------------------------------
#region
HORST_BLINK:
          lda           F_Eyes_open_Horst;Horsts Augen Flag laden
          cmp            #00       ; Auge zu? (0=Auge zu, 1 Auge auf, Startwert 1)
          beq            Horst_Auge_oeffnen:; ja -> weiter zu Horsts Auge_oeffnen:
                                   ; wenn nicht: Auge schliessen
;_____Horst auge schliessen
Horst_Auge_schliessen:
          ldx            SPRITE3DATA;lade Wert aus Spritepointer für Sprite 3
          inx                      ; (+1 = nächstern Spritedatenblock=Horst Auge zu)
          stx            SPRITE3DATA
          lda            #00
          sta           F_Eyes_open_Horst; Status auf "Auge zu"
          sta            C_Delay_Zwinkern_Horst; Verzögerungszähler auf 0 - > Start
          jmp            Kloss_Auge_wieder_oeffnen:
#endregion

;-----------------------------------------
; KLOSS: Auge wieder auf
;-----------------------------------------
#region
Kloss_Auge_wieder_oeffnen:
          lda            F_Eyes_open_Kloss;Kloß Augen Flag laden
          cmp            #00       ; Auge zu? (0=Auge zu, 1 Auge auf, Startwert 1)
          bne            Spinne_Auge_oeffnen:; Wenn Auge offen, weiter zu Spinne Augen öffnen
          lda            C_Delay_Zwinkern_Kloss;Verzögerungszähler laden
          cmp            #08       ; mit gewünschter Durchlaufzahl vergleichen
          bne            BLINK_Counter_erhoehen:;noch nicht? Erhöhen
                                   ;wenn doch - Auge auf!#
          lda            #01
          sta            F_Eyes_open_Kloss; Status auf "Auge auf"

        ; checken, in welche Richtung Kloß blicken soll
        lda F_SPRECHER
        cmp #$01       ; spricht Norbert?
        beq R:KLOSS_BLICKT_ZU_NORBERT
        cmp #$03       ; spricht Spinne
        beq R:KLOSS_BLICKT_ZU_SPINNE
        ; ansonsten spricht niemand oder Kloß selbst: Augen nach unten!
        lda SPRITE1OFFSET_BLICK_STANDARD
        sta    SPRITE1DATA
        jmp            Spinne_Auge_oeffnen:

R:KLOSS_BLICKT_ZU_NORBERT
        lda SPRITE1OFFSET_BLICK_ZU_NORBERT
        sta    SPRITE1DATA
        jmp            Spinne_Auge_oeffnen:

R:KLOSS_BLICKT_ZU_SPINNE
        lda SPRITE1OFFSET_BLICK_ZU_SPINNE
        sta    SPRITE1DATA
        jmp            Spinne_Auge_oeffnen:

BLINK_Counter_erhoehen:
          inc            C_Delay_Zwinkern_Kloss; Verzögerungszähler erhöhen undn weiter zu IRQ_ENDE
          jmp            Spinne_Auge_oeffnen:
#endregion
;-----------------------------------------
; Spinne: Auge wieder auf?
;-----------------------------------------
#region
Spinne_Auge_oeffnen:
          lda            F_Eyes_open_Spinne;Spinne Augen Flag laden
          cmp            #00       ; Auge zu? (0=Auge zu, 1 Auge auf, Startwert 1)
          bne            Horst_Auge_oeffnen:; Wenn Auge offen, ans IRQ_ENDE:
          lda            C_Delay_Zwinkern_Spinne;Verzögerungszähler laden
          cmp            #08       ; mit gewünschter Durchlaufzahl vergleichen
          bne            BLINK_Counter_SPINNE_erhoehen:;noch nicht? Erhöhen
                                   ;wenn doch - Auge auf!
          ldx            SPRITE2DATA;lade Wert aus Spritepointer für Sprite 2
          dex                      ; ((-1 = voriger Spritedatenblock=KLoss Auge auf)
          stx            SPRITE2DATA
          lda            #01
          sta            F_Eyes_open_Spinne; Status auf "Auge auf"
          jmp            Horst_Auge_oeffnen:
BLINK_Counter_SPINNE_erhoehen:
          inc            C_Delay_Zwinkern_Spinne; Verzögerungszähler erhöhen undn weiter zu IRQ_ENDE
          jmp            Horst_Auge_oeffnen:
#endregion
;-----------------------------------------
; Horst: Auge wieder auf?
;-----------------------------------------
#region
Horst_Auge_oeffnen:
          lda            F_Eyes_open_Horst;Horst Augen Flag laden
          cmp            #00       ; Auge zu? (0=Auge zu, 1 Auge auf, Startwert 1)
          bne           R:IRQ_NORBERT_AUGENANIMATION ; Wenn Auge offen, ans IRQ_ENDE:
          lda            C_Delay_Zwinkern_Horst;Verzögerungszähler laden
          cmp            #08       ; mit gewünschter Durchlaufzahl vergleichen
          bne            BLINK_Counter_Horst_erhoehen:;noch nicht? Erhöhen
                                   ;wenn doch - Auge auf!
          ldx            SPRITE3DATA;lade Wert aus Spritepointer für Sprite 2
          dex                      ; ((-1 = voriger Spritedatenblock=Horst Auge auf)
          stx            SPRITE3DATA
          lda            #01
          sta            F_Eyes_open_Horst; Status auf "Auge auf"
          jmp            R:IRQ_NORBERT_AUGENANIMATION
BLINK_Counter_Horst_erhoehen:
          inc            C_Delay_Zwinkern_Horst; Verzögerungszähler erhöhen undn weiter zu IRQ_ENDE
; jmp IRQ_ENDE:   (läuft einfach durch)
#endregion

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      INTERRUPT 2: NORBERT AUGE + CURSOR             OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO



R:IRQ_NORBERT_AUGENANIMATION


 lda  F_Sprecher
  sta $4471       
 cmp #$01
 beq R:NORBERT_AUGE_AUF
 jmp R:NORBERT_AUGE_ZU
R:NORBERT_AUGE_AUF
 ldx SPRITE0OFFSET
 stx SPRITE0DATA
 jmp IRQ_2_CURSOR:
R:NORBERT_AUGE_ZU
  ldx SPRITE0OFFSET
 inx
 stx SPRITE0DATA
 
;-----------------------------------------
;Cursorblinken
;-----------------------------------------

#region
IRQ_2_CURSOR:
; ___________________ CURSOR Timer check
          lda            C_Delay_Cursor;aktuellen Delaycounter aus Speicher holen
          cmp            #$18      ;Gewünschte Anzahl Durchlauefe
          bne           R:IRQ_SPRACHANIMATION; Timer nicht abgelaufen? Weiter zu IRQ Kloss
; Wenn Timer abgelaufen ist:
; __________________ CURSOR ausschalten oder anschalten?
        jsr            SR:GET_RND 

        sta $4473

         lda            F_Cursor_on_off;gucken, ob cursor an oder aus
     
          cmp            #$00      ;vergleiche mit Wert "cursor off"
          bne            Cursor_ausschalten:;wenn nicht zu, gehe zu "CURSOR aus", sonst weiter
                                   ;wenn zu "Cursor an"
; __________________Cursor anschalten
Cursor_anschalten:
          lda            CURSOR_PIXEL
          and            #%00111111;erstes von 4 MC-Pixels clearen
          ora            #%10000000; %11 (Farbe3) in 2. Pixel, Rest bleibt wie                             er war
          sta            CURSOR_PIXEL
          sta            CURSOR_PIXEL+1
          lda            #01
          sta            F_Cursor_on_off; Flag auf "An"
          lda            #$00
          sta            C_Delay_Cursor; Delay wieder auf 0
          jmp            R:IRQ_SPRACHANIMATION
; __________________ Cursor ausschalten
Cursor_ausschalten:
          lda            CURSOR_PIXEL
          and            #%00111111; erstes  Pixel clearen
          ora            #%01000000; %01 (Farbe 1) in letztes Pixel
          sta            CURSOR_PIXEL
          sta            CURSOR_PIXEL+1
          lda            #00
          sta            F_Cursor_on_off; Flag auf "Aus"
          lda            #$00
          sta            C_Delay_Cursor; Delay wieder auf 0
          jmp            R:IRQ_SPRACHANIMATION
#endregion


;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      INTERRUPT 2: SPRACHANIMATion                   OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

R:IRQ_SPRACHANIMATION


 lda  C_delaycounter_sprachanimation
 sta $4477
 cmp  #$06   ; delaycounter abgelaufen?
 bne JUMP_TO_R:IRQ_2_FINISH ; nö? dann nichts verändern und ans Ende!


 

 lda #$00
 sta C_delaycounter_sprachanimation  ; Verzögerungsschleife für nächste Mundphase neu starten

 lda F_Sprecher ; wer spricht?
 beq JUMP_TO_R:NIEMAND_SPRICHT

 cmp #$01 ; spricht Norbert?
 beq JUMP_TO_R:NORBERT_MUND_ANIMATION
 cmp #$02 ; spricht kloss?
 beq JUMP_TO_R:KLOSS_MUND_ANIMATION
 cmp #$03 ; spricht spinne?
 beq JUMP_TO_R:SPINNE_MUND_ANIMATION
 jmp R:IRQ_2_FINISH


;SPRUNGSCHANZEN

JUMP_TO_R:NIEMAND_SPRICHT

 jmp R:NIEMAND_SPRICHT


JUMP_TO_R:NORBERT_MUND_ANIMATION
 jmp R:NORBERT_MUND_ANIMATION

JUMP_TO_R:IRQ_2_FINISH
 jmp R:IRQ_2_FINISH



JUMP_TO_R:KLOSS_MUND_ANIMATION
 jmp R:KLOSS_MUND_ANIMATION

JUMP_TO_R:SPINNE_MUND_ANIMATION
 jmp R:SPINNE_MUND_ANIMATION

;-----------------------------------------
;Spriteanimation NORBERTS Mund und Bauch
;-----------------------------------------
R:NIEMAND_SPRICHT

    lda SPRITE6OFFSET           ; Münder auf Anfangswert
    sta SPRITE6DATA 
    lda SPRITE7OFFSET
    sta SPRITE7DATA
    lda SPRITE4OFFSET
    sta SPRITE4DATA
    lda SPRITE5OFFSET
    sta SPRITE5DATA

 jmp R:DELAY_COUNTER_RESET_UND_ENDE


;-----------------------------------------
;Spriteanimation NORBERTS Mund und Bauch
;-----------------------------------------





R:NORBERT_MUND_ANIMATION

;BAUCH ANIMATION
 jsr SR:GET_RND

        adc #$01
        and #%00000011           ;Zufallswert zwischn 0 und 2 hoch 2=4
;        sbc #01
        adc SPRITE5OFFSET        ; addiere diesen als offset zum Startwert des Spriteblockes  
     sta SPRITE5DATA 
    
;MUND ANIMATION
 jsr SR:GET_RND

        adc #$01
        and #%00000011           ;Zufallswert zwischn 0 und 2 hoch 2=4
;        sbc #01
        adc SPRITE4OFFSET        ; addiere diesen als offset zum Startwert des Spriteblockes 

        sta SPRITE4DATA        ; speichere das Ergebins im Sprite 6 pointer
       
 jmp R:DELAY_COUNTER_RESET_UND_ENDE

;-----------------------------------------
;Spriteanimation Kloßens Mund
;-----------------------------------------

R:KLOSS_MUND_ANIMATION
 
 jsr SR:GET_RND
        
        and #%00000101           ;Zufallswert zwischn 0 und 2 hoch 3=8
;        sbc #01
        adc SPRITE6OFFSET        ; addiere diesen als offset zum Startwert des Spriteblockes      
        sta SPRITE6DATA        ; speichere das Ergebins im Sprite 6 pointer
        sta $4474
       
 jmp R:DELAY_COUNTER_RESET_UND_ENDE

;-----------------------------------------
;Spriteanimation Spinnes Mund
;-----------------------------------------

R:SPINNE_MUND_ANIMATION
 
 jsr SR:GET_RND

        and #%00000111           ;Zufallswert zwischn 0 und 2 hoch 3=8
        sbc #01
        adc SPRITE7OFFSET        ; addiere diesen als offset zum Startwert des Spriteblockes      
        sta SPRITE7DATA        ; speichere das Ergebins im Sprite 6 pointer
        sta $4474
        jmp R:DELAY_COUNTER_RESET_UND_ENDE ; noch überflüssig, später evtl. nötig


;-----------------------------------------
;IRQ ENDE
;-----------------------------------------

R:DELAY_COUNTER_RESET_UND_ENDE

        lda #$00
        sta C_delaycounter_sprachanimation

R:IRQ_2_FINISH

        inc            C_Delay_Norbert;Counter erghöhen
        inc            C_Delay_Cursor
        lda      C_Delay_Cursor
        sta   $4475
        inc           C_delaycounter_sprachanimation
 

 lda C_countdown_sprachdauer
  sta $4476
 cmp #$00
 bne R:COUNTDOWN_SPRACHDAUER
 lda #$00
 sta F_Sprecher
 lda #$0f
 sta M_Standard_Farbe_Texthintergrund 
;  jsr SR:CLEARSCREEN
 jmp R:TEST


R:COUNTDOWN_SPRACHDAUER
 dec C_countdown_sprachdauer


R:TEST
   lda            M_Standard_Farbe_Rahmen

          sta            $D020    ; Hintergrund wieder schwarz




          lda            #<MyIRQ:  ;Adresse des 1. IRQ
          sta            $0314     ;den RAM-Vektor
          lda            #>MyIRQ:
          sta            $0315
          lda            #V_RASTER   ;Raster 1 aktivieren
          sta            $D012
          lda            #%00000001;IRQ bestätigen
          sta            $D019
          jmp            $EA31     ;zum Schluß zum 'Timer-Interrupt' springen

         
        
         
    



#endregion