
;************************************
;*       VIC BANK UMSCHALTEN      ***
;************************************
#region
          lda            #%00000011;Datenrichtung für BIT 0 & 1 des Port-A
          sta            $DD02     ;zum Schreiben freigeben
          lda            #%00000010;Bank-1
          sta            $DD00     ;auswählen
#endregion



#endregion
;************************************
;*       Bitmap zeigen            ***
;************************************
#region
;***Bitmap-Modus aktivieren
          lda           $D011     ;VIC-II Register 17 in den Akku
          ora            #%00100000;Bitmap-Modus
          sta            $D011     ;aktivieren
          lda            $D016     ;VIC-II Register 22 in den Akku
          ora            #%00010000;Multi-Color über BIT-4
          sta            $D016     ;aktivieren
                                   ;*** Start des Bitmapspeichers festlegen
          lda            $D018     ;VIC-II Register 24 in den Akku holen
          and            #%11110111;Mit BIT-3
          ora            #VICBITMAPBBLOCKNO*8;den Beginn des
          sta            $D018     ;Bitmapspeichers festlegen
          jsr            showKoala ;Koala-Bild anzeigen
          jmp            *         ;Endlosschleife
;*** Unkomprimiertes Koalabild anzeigen
;*** Offset (hex): Inhalt
;*** 0000 - 1F3F : Bitmap 8000 Bytes
;*** 1F40 - 2327 : Bildschirmspeicher 1000 Bytes
;*** 2328 - 270F : Farb-RAM 1000 Bytes
;*** 2710        : Hintergrundfarbe 1 Byte
showKoala
          ldx            #$00
@soop
          lda            VICBITMAPADR+$1F40,X;Farbe für Bildschirm-Speicher lesen
          sta            VICSCREENRAM,X;und schreiben
          lda            VICBITMAPADR+$2328,X;Farbe für COLOR-RAM lesen
          sta            VICCOLORRAM,X;und schreiben
          lda            VICBITMAPADR+$2040,X;für die nächsten drei Pages wiederholen
          sta            VICSCREENRAM+256,X
          lda            VICBITMAPADR+$2428,X
          sta            VICCOLORRAM+256,X
          lda            VICBITMAPADR+$2140,X
          sta            VICSCREENRAM+512,X
          lda            VICBITMAPADR+$2528,X
          sta            VICCOLORRAM+512,X
          lda            VICBITMAPADR+$2240,X
          sta            VICSCREENRAM+768,X
          lda            VICBITMAPADR+$2628,X
          sta            VICCOLORRAM+768,X
          dex                      ;Schleifenzähler verringern
          bne            @soop     ;solange ungleich 0 -> @loop
          lda            #$00
          sta            $D021     ;Hintergrundfarbe setzen
          
#endregion

