;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                          SUBROUTINEN                                OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

#region

;------------------------------------------
;Zufallszahl holen
;------------------------------------------

SR:GET_RND                           
          lda            $DC04     ;Low-Byte  von Timer A aus dem CIA-1
          eor            $DC05     ;High-Byte von Timer A aus dem CIA-1
          eor            $DD04     ;Low-Byte  von Timer A aus dem CIA-2
          adc            $DD05     ;High-Byte von Timer A aus dem CIA-2
          eor            $DD06     ;Low-Byte  von Timer B aus dem CIA-2
          eor            $DD07     ;High-Byte von Timer B aus dem CIA-2
         
          rts


;------------------------------------------
;Neue Taste gedrückt?
;------------------------------------------

SR:WAIT_FOR_KEY

R:WAIT_FOR_KEY 
    lda $CB                      ;Matrixkoordinate lesen
    cmp M_Tastaturspeicher       ;noch immer selbe Taste gedrückt?
    beq R:WAIT_FOR_KEY            ; ja? weiter warten!



    cmp #$40                    ;besteht die änderung darin, dass
                               ;jetzt keine Taste mehr gedrückt ist?
    beq  R:WAIT_FOR_KEY        ; ja? Weiter warten!
  
    rts



;------------------------------------------
;Neue Taste gedrückt? Mit Colorcycling
;------------------------------------------



SR:WAIT_FOR_KEY_COLORCYCLE 
     
R:INIT_COLORCYCLE        
 ldx  #$00
       
R:KEY_COLORCYCLE 
 
        lda cyclecolors,x
      

       sta  SPRITEMULTICOLOR1

 

  cmp #$ff
        beq R:INIT_COLORCYCLE

        
          
        inx
  ldy #$00
R:KLEINE_WARTESCHLEIFE
 iny



 bne R:KLEINE_WARTESCHLEIFE
 
 



    lda $CB                      ;Matrixkoordinate lesen
    cmp M_Tastaturspeicher       ;noch immer selbe Taste gedrückt?
    beq R:KEY_COLORCYCLE        ; ja? weiter warten!



    cmp #$40                    ;besteht die änderung darin, dass
                               ;jetzt keine Taste mehr gedrückt ist?

  


    beq  R:KEY_COLORCYCLE       ; ja? Weiter warten!
  
    rts

  
@wait 

 lda $CB
 cmp #$40
 beq @wait

cyclecolors

 
; byte $00, $00,$00,$02, $02, $02, $08, $08,$08,$07, $07,$07,$01, $01,$01,$07,$07,$07,$08,$08,$08,$02, $02,$02,$ff    


  byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

 byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06
  byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06
 byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06

   byte $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
 byte $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
 

;  byte $01,  $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01, $01



 
   byte $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
 byte $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
 

 byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06
  byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06
 byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06

 byte $ff


; byte $00,$06,$0e,$01,$0e,$06, $ff


;------------------------------------------
;16 Bit Verzögerungsschleife
;------------------------------------------

SR:16BIT_DELAY
 ldy #$00

R:16BIT_DELAY_OUTER_CIRCLE

 ldx #$00 

R:16BIT_DELAY_INNER_CIRCLE
 
 inx
 bne R:16BIT_DELAY_INNER_CIRCLE
 iny
 cpy  V_Delay_x_256
 bne R:16BIT_DELAY_OUTER_CIRCLE
 rts

;------------------------------------------
;Screenram mit multicolorfarbe füllen
;------------------------------------------

SR:FILLSCREEN_WITH_COLOR

 ldx #$0                         ;Schleifenzähler 256 BYTES
 lda M_Fillscreen_Color
 
R:COLOR_FILL_LOOP

 sta VICSCREENRAM,X             ;1. Page des Bildschirmspeichers
 sta VICSCREENRAM+256,X         ;2. Page
 sta VICSCREENRAM+512,X         ;3. Page
 inx                            ;Schleifenzähler erhöhen
 bne R:COLOR_FILL_LOOP         ;solange nicht 0 nochmal -> @loop
 
 ldx #$0                         ;Schleifenzähler 256 BYTES
 
 
R:COLOR_FILL_LOOP_PAGE_4

 sta VICSCREENRAM,X+768             ;4. Page des Bildschirmspeichers
 
 inx                            ;Schleifenzähler erhöhen
 cpx #$e7                          ; die letzten 24 Bytes sind für die Sprites da
 bne R:COLOR_FILL_LOOP_PAGE_4          ;solange nicht 0 nochmal -> @loop

 rts

;-----------------------------------------
; Farben SAVEN
;------------------------------------------
   
SR:SAVE_COLORS


 ldx #$0                         ;Schleifenzähler 256 BYTES
 lda #$ff                       ;0 in den Akku
R:COLOR_SAVE_LOOP
 
 lda VICSCREENRAM,X 
 sta S_SAVE_COLORS,X        ;1. Page des Bereiches für die Sicherheitskopie

 lda VICSCREENRAM+256,X   
 sta S_SAVE_COLORS+256,X  
       
 lda VICSCREENRAM+512,X         ;3. Page
 sta S_SAVE_COLORS+512,X  
 
 inx                            ;Schleifenzähler erhöhen
 bne R:COLOR_SAVE_LOOP                    ;solange nicht 0 nochmal -> @loop

 ;4. Page des Bildschirmspeichers
R:COLOR_SAVE_LOOP_PAGE_4

 sta VICSCREENRAM+768,X 
 lda S_SAVE_COLORS+768,X   ;4. Page des Bildschirmspeichers    
 inx                            ;Schleifenzähler erhöhen
 cpx #$e8                         ; die letzten 24 Bytes sind für die Sprites da
 bne R:COLORS_BACK_LOOP_PAGE_4         ;solange nicht 0 nochmal -> @loop

 rts

;-----------------------------------------
; Farben Restore
;------------------------------------------

   
 
SR:GET_BACK_COLORS


 ldx #$0                         ;Schleifenzähler 256 BYTES
 lda #$ff                       ;0 in den Akku
R:COLORS_BACK_LOOP
 

 lda S_SAVE_COLORS,X        ;1. Page des Bereiches für die Sicherheitskopie
 sta VICSCREENRAM,X             ;1. Page des Bildschirmspeichers
 
 lda S_SAVE_COLORS+256,X  
 sta VICSCREENRAM+256,X         
 
 lda S_SAVE_COLORS+512,X  
 sta VICSCREENRAM+512,X         ;3. Page

 inx                            ;Schleifenzähler erhöhen
 bne R:COLORS_BACK_LOOP                    ;solange nicht 0 nochmal -> @loop

R:COLORS_BACK_LOOP_PAGE_4

 lda S_SAVE_COLORS+768,X  
 sta VICSCREENRAM+768,X           ;4. Page des Bildschirmspeichers
 
 inx                            ;Schleifenzähler erhöhen
 cpx #$e7                          ; die letzten 24 Bytes sind für die Sprites da
 bne R:COLORS_BACK_LOOP_PAGE_4         ;solange nicht 0 nochmal -> @loop
 

 lda V_Standard_Farbe_Hintergrund
 sta M_Standard_Farbe_Hintergrund

 lda V_Standard_Farbe_Rahmen 
 sta M_Standard_Farbe_Rahmen 
 
 lda V_Standard_Farbe_Texthintergrund
 sta M_Standard_Farbe_Texthintergrund
 rts


;-----------------------------------------
; (Text)Bildschirm löschen
;------------------------------------------

  
SR:CLEARSCREEN
; oberen Grafikbildschirm-Color-Ram mit hellgrauer Hintergrundfarbe füllen
 lda $4400
 cmp #$ff ; ist er bereits mit ff /hellgrau) gefüllt?
 beq R:RETURN_FROM_CLEARSCREENLOOP 

 ldx #120
 lda #$ff
 ;(war #32)
R:CLEARSCREENLOOP
 dex
 sta $4400,x
 
 bne R:CLEARSCREENLOOP
R:RETURN_FROM_CLEARSCREENLOOP 
 rts


SR:CLEARTEXT
; Textfesnster mit Leerzeichen füllen

 ldx #120
 lda #32

R:CLEARTEXTLOOP
 dex
 sta $4400,x
 
 bne R:CLEARTEXTLOOP
 rts




#endregion